#ifndef PHONGSHADER_HXX
#define PHONGSHADER_HXX

#include "Shader.hxx"

class PhongShader : public Shader
{
public:
  PhongShader(Scene* scene,
	      const Vec3f& ambient_color,
	      const Vec3f& diffuse_color,
	      const Vec3f& specular_color,
	      float ka,
	      float kd,
	      float ks,
	      float ke);
  virtual ~PhongShader();
  
  virtual Vec3f Shade(Ray& ray);
private:
  PhongShader();
  
  Vec3f m_ambient_color, m_diffuse_color, m_specular_color;
  float m_ka, m_kd, m_ks, m_ke;
};
#endif
